package helper

import "testing"

func MaxInt(numbers []int) int {
	if len(numbers) == 0 {
		panic("Пустой массив передан в функцию MaxInt")
	}

	max := numbers[0]

	for i := 1; i < len(numbers); i++ {
		if numbers[i] > max {
			max = numbers[i]
		}
	}

	return max
}

func failure(t *testing.T) {
	t.Helper()
	t.Fatal("failure")
}

func TestMaxInt(t *testing.T) {

	input := []int{1, 2, 3, 4, 5}
	expectedOutput := 5

	result := MaxInt(input)

	if result != expectedOutput {
		failure(t)
	}
}
