package setenv

import (
	"os"
	"testing"
)

func MyFunction() string {
	value := os.Getenv("MY_ENV_VAR")
	return value
}

func TestMyFunction(t *testing.T) {
	// t.Setenv("MY_ENV_VAR", "some value")

	result := MyFunction()
	expected := "some value"
	if result != expected {
		t.Errorf("MyFunction() returned %s, expected %s", result, expected)
	}
}
