package runParallel

import (
	"testing"
)

func BenchmarkParallel(b *testing.B) {
	var data []int
	for i := 0; i < 100000000; i++ {
		data = append(data, i)
	}
	b.ResetTimer()

	b.RunParallel(func(pb *testing.PB) {
		var sum int
		for pb.Next() {
			for _, num := range data {
				sum += num
			}
		}
	})
}
